# prepare-redhat.sap_install

## Preparing the collection redhat.sap_install from upstream

1. Clone the main branch of the repository https://github.com/sap-linuxlab/community.sap_install.git.

2. Run the command `tools/prepare-files.sh` of the repo https://gitlab.cee.redhat.com/sap-linuxlab/redhat.sap_install to prepare
   certain downstream files which differ from their upstream versions.

   Before executing, check the variable settings of the script. Their meaning is as follows:
   - `UPSTREAM_COLLECTION_PATH`: The directory where you cloned the upstream repo
   - `PREPARE_SAP_INSTALL`: The directory into which this repo has been cloned
   - `DOWNSTREAM_COLLECTION_PATH`: A directory into which the modified files will be copied

3. After executing the `tools/prepare-files.sh` script, copy the files from `DOWNSTREAM_COLLECTION_PATH` over the corresponding files in the   cloned upstream repo `UPSTREAM_COLLECTION_PATH`.
   The following commands can be used for this purpose:
   ```
   UPSTREAM_COLLECTION_PATH=~/.ansible/collections/ansible_collections/community/sap_install
   DOWNSTREAM_COLLECTION_PATH=~/.ansible/collections/ansible_collections/built-redhat.sap_install
   cd ${DOWNSTREAM_COLLECTION_PATH}/files
   for file in $(find . -type f); do
      _PATH=$(dirname $file)
      _FILE=$(basename $file)
      cp ${_PATH}/${_FILE} ${UPSTREAM_COLLECTION_PATH}/${_PATH}/${_FILE}
   done
   ```

4. Create the Automation Hub collection and the RHEL package from the now updated cloned upstream repo.
